*STEP 1 IS TO GET THE STATISTICS ON PI, BETA, AND ALPHAS THAT I WILL USE IN SIMULATION;
*THESE STATISTICS ARE BASED ON 2000 CENSUS;
*CLASSIFY SKILL AS MORE THAN HIGH SCHOOL;

#delimit ;
log using /volumes/ddisk/immigration/programs/chapter_7/Table_7_1.log, replace;


use "/Volumes/Ddisk/Immigration/Programs/Chapter_4/Aggregate/count_nat_mf.dta", clear;
collapse (sum) immiglf nativelf, by(survey edcode);
keep if survey==2000;
gen lf=immiglf+nativelf;
egen tot=sum(lf);

generate good=.;
replace good=1 if edcode>=3;
egen skill=sum(good*lf);
gen pis=skill/tot;

list edcode pis;


use "/Volumes/Ddisk/Immigration/Programs/Chapter_4/Aggregate/count_nat_mf.dta", clear;
collapse (sum) immiglf, by(survey edcode);
keep if survey==2000;
egen tot=sum(immiglf);

generate good=.;
replace good=1 if edcode>=3;
egen skill=sum(good*immiglf);
gen beta=skill/tot;

list edcode beta;



use "/Volumes/Ddisk/Immigration/Programs/Chapter_5/share_mf.dta", clear;

collapse (mean) sharei, by(edcode);
keep if edcode>=3;

egen alphas=sum(sharei);
list;


*NOW START THE ACTUAL SIMULATION;
clear;

#delimit cr


input double (pis alphas eps_uu eps_ss beta)
.614 .501 -.3 -.5 .489
.614 .501 -.6 -.9 .489
.614 .501 -.3 -.5 0.0
.614 .501 -.3 -.5 1.0
.614 .501 -.6 -.9 0.0
.614 .501 -.6 -.9 1.0
end

list


#delimit ;
set more 1;

*THIS PROGRAM ONLY USES THE FORMULAS FROM THE HANDBOOK ARTICLE TO CALCULATE THE NET GAINS;	
*USES THE BENEFIT.RAW DATASET TO FEED IN BASIC VALUES;

generate eps_su=.05;

*THE ALPHAS ARE INCOME SHARES;
*THE EPSILONS ARE THE FACTOR PRICE ELASTICITIES;
*THE Pi'S ARE LABOR SHARES;	

list;

generate piu = 1 - pis;
generate alphau = .7 - alphas;
generate alphak = .3;
generate eps_us=(alphas/alphau)*eps_su;

*NOTE THAT P IS IMMIGRANT SHARE;

generate p=.150;
generate m=p/(1-p);

*b IS FRACTION OF NATIVE WORKFORCE THAT IS SKILLED;	
generate b=pis*(1+m) - beta*m;

*METHOD USING FORMULA IN HANDBOOK;
*SHORT RUN;


generate term1=-alphas*eps_ss*(beta*p/pis)^2;
generate term2=-alphau*eps_uu*((1-beta)*p/piu)^2;
generate term3=-alphas*eps_su*beta*(1-beta)*(p^2)/(pis*piu);

*MULTIPLIES FIRST TWO TERMS BY 1/2 TO TAKE CARE OF DERIVATIVE PROPERTY;
replace term1=term1/2;
replace term2=term2/2;
generate gain_sr=term1+term2+term3;
generate dgain_sr=gain_sr*15000;

drop term*;

*LONG RUN;

generate eps_ks= -(alphau*eps_us + alphas*eps_ss)/.3;
generate eps_ku= -(alphau*eps_uu + alphas*eps_su)/.3;
generate eps_kk = -eps_ks - eps_ku;

generate css=eps_ss/alphas;
generate cuu=eps_uu/alphau;
generate csu=eps_su/alphau;
generate ckk=eps_kk/.3;
generate csk=eps_ks/alphas;

generate term1=-(alphas^2)/(2*ckk);
generate term2=(css*ckk - csk^2);
generate term3=((beta - b)^2)/((pis*piu)^2);
generate term4=((1-p)^2)*(p^2);

*TERM1 IS ALREADY DIVIDED BY 2 TO TAKE CARE OF DERIVATIVE PROPERTY;

generate gain_lr=term1*term2*term3*term4;
generate dgain_lr=gain_lr*15000;

list pis alphas eps* beta gain_sr dgain_sr gain_lr dgain_lr;


log close;

