input R
2
3
4
5
6
end

list

#delimit ;
set more 1;
log using /volumes/ddisk/immigration/programs/chapter_7/Table_7_3.log, replace;

*NOTE ALL NUMBERS ARE IN BILLIONS;
generate gdp=70000;
generate labor0 = 2.7;
generate labor1 = 0.6;
generate delta = -0.3;

*R is the ratio of wages;
*A is the ratio of the alphas, alpha1/alpha0;
generate A = R*(labor0/labor1)^delta;
generate k = A^(1/delta);
generate M = (labor0 - k*labor1)/(1 + k);

*NOW GET VALUE OF THE CONSTANTS ALPHA1 AND ALPHA0;
*SOLVE FOR ALPHA0;

generate numer = (1 + delta)*gdp;
generate denom = A*(labor1^(1+delta)) + labor0^(1+delta);
generate alpha0 = numer/denom;
generate alpha1 = A*alpha0;

*NOW GET THE CHANGE IN GDP;
*SOLVE TWO TERMS SEPARATELY AND THEN ADD;

generate new1 = labor1+M;
generate new0 = labor0-M;

generate gain1 = (alpha1/(1+delta))*(new1^(1+delta) - labor1^(1+delta));
generate gain0 = (alpha0/(1+delta))*(labor0^(1+delta) - new0^(1+delta));
generate gain = gain1 - gain0;
generate pgain = gain/gdp;

list R gain pgain;

*DECLINE IN EARNINGS OF NATIVES IN NORTH;

*IN-MIGRATION RATE;
generate inmig_rate=(M+labor1)/labor1;
generate loss_other=inmig^delta - 1;
list R inmig_rate loss_other;

*MRATE IS THE MOBILITY RATE FROM WORKFORCE;
*GET # OF POPULATION MOVERS BY MULTIPLYING MOBILITY RATE TIMES THE 6 BILLION PEOPLE IN THE SOUTH;

generate mrate = M/labor0;
generate double movers = mrate*5.9;

list R gain movers;

*NOW CONVERT TO ACTUAL UNITS;
*MULTIPLY BY 1 BILLION;
*AND TAKE PRESENT VALUE AT DISCOUNT RATE OF 5 PERCENT;

generate double pv = gain*1000000000/.05;
replace movers = movers*1000000000;

generate breakeven=pv/movers;

list R M mrate gain pgain breakeven;

log close;


